# #!/usr/bin/env python3

# mysql remote

import time
import sys
import os
import subprocess
from subprocess import PIPE, Popen

import log_errors as log



### for complex cmd args, may not be obvious how to split them so use shlex 
# >>> import shlex, subprocess
# >>> command_line = input()
# /bin/vikings -input eggs.txt -output "spam spam.txt" -cmd "echo '$MONEY'"
# >>> args = shlex.split(command_line)
# >>> print(args)
# ['/bin/vikings', '-input', 'eggs.txt', '-output', 'spam spam.txt', '-cmd', "echo '$MONEY'"]
# >>> p = subprocess.Popen(args) # Success!

#input is an array of strings
def executeProcess(sCmdArgs):
    #s = subprocess.check_output(["echo", "Hello World!"])
    #s = subprocess.check_output([sCmd, sArgs])
    #return_str = str(s)
    
    #use non-blocking Popen with timeout and kill proc if timed-out 
    #proc = subprocess.Popen(sCmdArgs, stdout=PIPE, stderr=PIPE, shell=True)
    
    #set a default return value
    outs = 'ok'
    
    for i in range(5):
        try:
            results = subprocess.run(sCmdArgs, capture_output=True, text=True)
            #print(ls)
            #proc = subprocess.Popen(sCmdArgs, stdout=PIPE, stderr=PIPE)
            #outs, errs = proc.communicate(timeout=120)
            outs = results.stdout
            #errs = results.stderr
            
            if(outs == ''):
                outs = 'ok'   #for write ops, no return value
            
        except TimeoutExpired:
            outs = 'notOk'
            sMsg = str(i) + "th try in executeProcess(..) in ssh_mySQL.py "
            log.write_debug_log(sMsg)
            time.sleep(15)
            if(k>=4):
                sMsg = sCmdArgs + " | giving up in executeProcess(..) in ssh_mySQL.py "
                log.write_debug_log(sMsg)
                results.kill()
                #outs, errs = proc.communicate()    
        else:  #was successful, so exit loop
            break
        
    return outs

     


#input is an array of strings
def old_executeProcess(sCmdArgs):
    #s = subprocess.check_output(["echo", "Hello World!"])
    #s = subprocess.check_output([sCmd, sArgs])
    #return_str = str(s)
    
    #use non-blocking Popen with timeout and kill proc if timed-out 
    #proc = subprocess.Popen(sCmdArgs, stdout=PIPE, stderr=PIPE, shell=True)
    
    for i in range(5):
        proc = subprocess.Popen(sCmdArgs, stdout=PIPE, stderr=PIPE)
        try:
            outs, errs = proc.communicate(timeout=120)
            
        except TimeoutExpired:
            sMsg = str(i) + "th try in executeProcess(..) in ssh_mySQL.py "
            log.write_debug_log(sMsg)
            time.sleep(15)
            if(k>=4):
                sMsg = sCmdArgs + " | giving up in executeProcess(..) in ssh_mySQL.py "
                log.write_debug_log(sMsg)
                proc.kill()
                outs, errs = proc.communicate()    
        else:  #was successful, so exit loop
            break
        
    return outs, errs

     


def mySQL_over_SSH(sServer, port, sUser, sPswd, sDataBase, sQuery):
    
    sPort = str(port)
    sPortArg = "-p " + sPort

    sMySQL_cmd = "mysql -u " + sUser + " -p" + sPswd + " -D " + sDataBase + " -e '" + sQuery + "'"

    #print("sql_cmd: ", sMySQL_cmd)
    #print()

    sCmd = ["ssh"]

    #works
    #sArgs = [sServer, sPortArg, "mysql -u ginuser -pHello2018 -D camera_nodes -e 'select * from city;' "] 
    #works
    sArgs = [sServer, sPortArg, sMySQL_cmd] 

    sCmdArgs = sCmd + sArgs

    results = executeProcess(sCmdArgs)
  
    return results





#type hints
from collections.abc import Sequence
import typing
from typing import Dict, Any, List

SQL_DICT_INFO = Dict[str,Any]
SKEYS = List[str]
SVALS = List[str]


def gen_mySQL_Insert_Query(tableName:str, Dict_Info:SQL_DICT_INFO ) ->str:
    sQuery = 'INSERT INTO CamNodes_Info('
    sKeys = ""
    sVals = ""
    length = len(Dict_Info) - 1
    print("length: ", length)
    for i, key in enumerate(Dict_Info):
        if(i==length):
            break
        
        print()
        print("i: ", i)
        print("key: ", key)
        
        val =  Dict_Info[key] 
        
        t =str(type(Dict_Info[key]))
        if("int" in t):
            t = "int"
            sVals = sVals + str(val)
        else:
            t = "str"
            sVals = sVals + '"' + val + '"'
            print(sVals)

        sKeys = sKeys + key
        
        if(i < length-1):
            sKeys = sKeys + ","
            sVals = sVals + ","
        
        #print("sKeys: ", sKeys)
        #print("sVals: ", sVals)
    
    sQuery = sQuery + sKeys + ') VALUES (' + sVals + ');'
    return(sQuery)
    








